#!/usr/bin/php
<?

function scanf($msg, $values=array(), $length=64, $isupper=true, $allownull=false)
{
	echo $msg;
	// [2006-09-06] AnNyung 1.2  php stdin   ߰ߵ.
	// [2006-11-13] Windows PHP 5.2.0  Է¾ȵǴ  .
	// [2006-11-14] RWAPM  STDIN   ʴ  ߰.
	if (defined('STDIN'))
	{
		$data = trim(fgets(STDIN,$length));
	} else
	{
		$stdin = (file_exists("/dev/stdin")) ? "/dev/stdin" : "php://stdin";
		$fp = fopen($stdin,"r");
		$data = trim(fgets($fp,$length));
		fclose($fp);
	}	// if()
	if ($isupper)
		$data = strtoupper($data);

	if ($values && $data == '')
	{
		$data = $values[0];
	}	// if()

	if (!$allownull && ($data == '' || ($values && sizeof($values) > 1 && !in_array($data, $values))))
	{
		$data = scanf($msg, $values, $length, $isupper);
	}	// if()

	return $data;
}	// function()

function Agent($extension_dir_ori, $extension_dir)
{
	if(strcasecmp($extension_dir_ori, $extension_dir)) {
		echo " Ʈ PHP ΰ Ǿϴ.\n";
		echo "  Ͽ ϵ  - ".$extension_dir_ori."\n";
		echo "    - ".$extension_dir."\n\n";
		echo " θ   ڵ մϴ.\n";

		$target_file = array(
								'tools\NmailPHPAgent\NmailPHPAgent\TaskNmailDbOptimize.ini',
								'tools\NmailPHPAgent\NmailPHPAgent\TaskNmailDbSync.ini',
								'tools\NmailPHPAgent\NmailPHPAgent\NmailAgent.ini',
							);

		for ($i=0; $i<sizeof($target_file); $i++)
		{
			$fp = fopen($target_file[$i], "r");
			$file_read_ori = fread($fp, filesize($target_file[$i]));
			fclose($fp);
			$file_read = $file_read_ori;
			$file_read = str_replace(str_replace('\\', '\\\\', $extension_dir_ori), str_replace('\\', '\\\\', $extension_dir), $file_read);
			$file_read = str_replace($extension_dir_ori, $extension_dir, $file_read);

			if (strcasecmp($file_read, $file_read_ori))
			{
				$fp = fopen($target_file[$i], "w");
				fwrite($fp, $file_read);
				fclose($fp);
				echo "  ".$target_file[$i]." - Ϸ\n";
			} else
			{
				echo "  ".$target_file[$i]." - \n  []\n    ʾҽϴ.\n     ġ θ ȮϽñ ٶϴ.\n";
				scanf("Ϸ ƹ Ű ʽÿ . . .", array(), 5, false, true);
				exit;
			}	// if()
		}	// for()
		echo " Ʈ PHP ΰ  Ǿϴ.\n";
	} else
	{
	echo " Ʈ PHP ΰ  ʾҽϴ.   ƹ   ʾҽϴ.\n";
	}
}

error_reporting(E_ALL ^ E_NOTICE);

echo "\n";
echo "==============================================================================\n";
echo "= [Nmail] ġ 丮 \n";
echo "==============================================================================\n";
echo "\n";

// php   NmailAgent  php   񱳸  ߰.
//$extension_dir = substr(ini_get('extension_dir'), 0, -3)."PHP.EXE";
//$fphp = "tools\NmailPHPAgent\NmailPHPAgent\TaskNmailDbOptimize.ini";
//$fp = fopen($fphp, 'r');
//while(!feof($fp)) {
//	$str = fgets($fp,10000);
//	$arr[] = $str;
//}
//fclose($fp);
//$extension_dir_ori = str_replace("\r\n","",str_replace('"', '', strstr($arr[1], '"')));

// ini   ...  global_var.php  ˾Ƴ .
$ini = 'nmail_dir.ini';
$ini_iscreate = false;
if (!file_exists($ini))
{
	echo " ġ ΰ ϵ (".$ini.")   մϴ.\n";
	define("_INCLUDED_GLOBAL", "1");
	chdir('nmail');
	if (!file_exists('include/global_var.php'))
	{
		copy('include/global_var.default.php', 'include/global_var.php');
	}	// if()
	include('include/global_var.php');
	chdir('../');
	$home_dir = str_replace('/', '\\', str_replace("/MailRoot/domains", '', $G_SYS[MAIL_ROOT]));
	echo "⺻ ġ (".$home_dir.") ˴ϴ.\n";
	echo "\n";
	$fp = fopen($ini, "w");
	fwrite($fp, $home_dir);
	fclose($fp);
	$ini_iscreate = true;
} else
{
	$home_dir = trim(implode(file('nmail_dir.ini')));
}	// if()

// ΰ Ǿ Ȯ.
$curr_dir = dirname(__FILE__);
if ($home_dir != $curr_dir)
{
	echo " ġ ΰ Ǿϴ.\n";
	echo "  Ͽ ϵ  - ".$home_dir."\n";
	echo "    - ".$curr_dir."\n\n";
	echo " θ   ڵ մϴ.\n";

	$target_file = array(
							'nmail\include\global_var.php',
							'tools\filter.bat',
							'tools\filter_out.bat',
							'tools\filter_pre_data.bat',
							'MailRoot\filters.pre-data.tab',
							'MailRoot\filters.post-data.tab',
							'MailRoot\filters\nmail.tab',
							'MailRoot\filters\nmail_out.tab',
							'tools\install_config.reg',
//							'tools\NmailPHPAgent\NmailPHPAgent\TaskNmailDbOptimize.ini',
//							'tools\NmailPHPAgent\NmailPHPAgent\TaskNmailDbSync.ini',
//							'tools\NmailPHPAgent\NmailPHPAgent\NmailAgent.ini',
							);

	for ($i=0; $i<sizeof($target_file); $i++)
	{
		$fp = fopen($target_file[$i], "r");
		$file_read_ori = fread($fp, filesize($target_file[$i]));
		fclose($fp);
		$file_read = $file_read_ori;
		$file_read = str_replace(str_replace('\\', '\\\\', $home_dir), str_replace('\\', '\\\\', $curr_dir), $file_read);
		$file_read = str_replace($home_dir, $curr_dir, $file_read);
		if (strcmp($file_read, $file_read_ori))
		{
			$fp = fopen($target_file[$i], "w");
			fwrite($fp, $file_read);
			fclose($fp);
			echo "  ".$target_file[$i]." - Ϸ\n";
		} else
		{
			echo "  ".$target_file[$i]." - \n  []\n    ʾҽϴ.\n     ġ θ ȮϽñ ٶϴ.\n";
			scanf("Ϸ ƹ Ű ʽÿ . . .", array(), 5, false, true);
			exit;
		}	// if()
	}	// for()

	echo " ġ θ Ͽ մϴ.\n";
	$fp = fopen($ini, "w");
	fwrite($fp, $curr_dir);
	fclose($fp);

	# Ʈ 
	echo " ġ θ Ʈ ߰ؾ մϴ.\nȮâ  []  ֽʽÿ.\n";
	system("tools\install_config.reg");
	# 񽺿 ڵ۵ǵ 
	system("MailRoot\bin\XMail --remove");
	system("MailRoot\bin\XMail --install-auto");
	system("net start XMail");

	echo " ġ ΰ  Ǿϴ.\n";

/*
	Agent($extension_dir_ori, $extension_dir);

	echo "NmailPHP Agent 񽺿 մϴ.\n";
	system("\"C:\\WINDOWS\\Microsoft.NET\\Framework\\v4.0.30319\\InstallUtil.exe\" " .$curr_dir."\\tools\\NmailPHPAgent\\NmailPHPAgent.exe");
	system("sc failure NmailPHPAgent actions= restart/60000 reset= 30");
*/
} else
{
	if ($ini_iscreate)
	{
		echo "ġ θ Ʈ ߰ؾ մϴ.\nȮâ  []  ֽʽÿ.\n";
		system("tools\install_config.reg");
		# 񽺿 ڵ۵ǵ 
		system("MailRoot\bin\XMail --remove");
		system("MailRoot\bin\XMail --install-auto");
		system("net start XMail");

		echo " ġ ΰ  Ǿϴ.\n";

/*
		Agent($extension_dir_ori, $extension_dir);

		echo "NmailPHP Agent 񽺿 մϴ.\n";
		system("\"C:\\WINDOWS\\Microsoft.NET\\Framework\\v4.0.30319\\InstallUtil.exe\" " .$curr_dir."\\tools\\NmailPHPAgent\\NmailPHPAgent.exe");
		system("sc failure NmailPHPAgent actions= restart/60000 reset= 30");
*/
	} else
	{
		echo " ġ ΰ  ʾҽϴ.   ƹ   ʾҽϴ.\n";
	}	// if()
}	// if()

//scanf("Ϸ ƹ Ű ʽÿ . . .", array(), 5, false, true);
?>